
!MCFileTreeStWriter methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'galatians 05/13/2005 14:15'!
writeDefinitions: aCollection
	"the correct initialization order is unknown if some classes are missing in the image"

	[ 
	aCollection do: [:ea | ea accept: self]
	 ] on: Error do: [ :ex | ex halt ]! !

!BinaryOrTextFile methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'galatians 05/13/2005 14:15'!
lineEndConvention: aSymbol
! !

!BinaryOrTextFile methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'galatians 05/13/2005 14:15'!
nextChunkPut: aString
	"Append the argument, aString, to the receiver, doubling embedded terminators."
 
	| i remainder terminator | 
	terminator := $!!.
	remainder := aString asString.
	[(i := remainder indexOf: terminator) = 0] whileFalse:
		[self nextPutAll: (remainder copyFrom: 1 to: i).
		self nextPut: terminator.  "double imbedded terminators"
		remainder := remainder copyFrom: i+1 to: remainder size].
	self nextPutAll: remainder. 
	aString asString includesUnifiedCharacter ifTrue: [
		self nextPut: terminator.
		self nextPutAll: ']lang['.
		aString writeLeadingCharRunsOn: self.
	].
	self nextPut: terminator.
! !

!BinaryOrTextFile methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'galatians 05/13/2005 14:15'!
store: anObject 
	"Have anObject print on the receiver for purposes of rereading."

	anObject storeOn: self! !

!CharacterCollection methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'galatians 05/13/2005 14:15'!
includesUnifiedCharacter
	^false! !

!CharacterCollection methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'galatians 05/13/2005 14:15'!
writeLeadingCharRunsOn: stream

	| runLength runValues runStart leadingChar |
	self isEmpty ifTrue: [^ self].

	runLength := OrderedCollection new.
	runValues := OrderedCollection new.
	runStart := 1.
	leadingChar := (self at: runStart) leadingChar.
	2 to: self size do: [:index |
		(self at: index) leadingChar = leadingChar ifFalse: [
			runValues add: leadingChar.
			runLength add: (index - runStart).
			leadingChar := (self at: index) leadingChar.
			runStart := index.
		].
	].
	runValues add: (self last) leadingChar.
	runLength add: self size + 1 -  runStart.

	stream nextPut: $(.
	runLength do: [:rr | rr printOn: stream. stream space].
	stream skip: -1; nextPut: $).
	runValues do: [:vv | vv printOn: stream. stream nextPut: $,].
	stream skip: -1.
! !

!ChangeList class methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'revelations 11/04/2011 15:50'!
parseSelector: methodString
	"
	ChangeList parseSelector: 'test'.
	ChangeList parseSelector: 'test2'.
	ChangeList parseSelector: 'test: arg1'.
	ChangeList parseSelector: 'test: arg1 test: arg2'.
	ChangeList parseSelector: '<= other
		4 < 5'.
	ChangeList parseSelector: '* other
		self / other'.
	ChangeList parseSelector: '//'.
	ChangeList parseSelector: 'test
		x := 1
		^x'.
	ChangeList parseSelector: 'test: arg1
		| x |
		x := 1
		^x'.
	ChangeList parseSelector: 'test: arg1 test: arg2
		<primitive: 617 >
		^nil'.
	ChangeList parseSelector: 'test: arg1 test: arg2
		""test""
		<primitive: 617 >
		^nil'.
	ChangeList parseSelector: 'test: arg1arg
		""test""
		<primitive: 617 >
		^nil'.	
	ChangeList parseSelector: 'renderListItem: html callbackEdit: block1 callbackRemove: block2 index: rowIndex 
	html tableRow
		backgroundColourStyleForRowNumber: rowIndex;
		with: 
			[ html tableData: 
				[ html anchor
					callback: block1;
					with: identifier ].
			html tableData: 
				[ html anchor
					callback: block2;
					id: rowIndex asString;
					with: ''Remove'' ] ]'
	"

	| str token selector c done tokens |
	str := ReadStream on: methodString.
	tokens := ReadStream on: (Scanner new scanTokens: str nextLine).
	selector := WriteStream on: String new.
	[ tokens atEnd ] whileFalse: [
		selector nextPutAll: tokens next.
		tokens atEnd ifFalse: [tokens next]].
	^selector contents
! !

!FileDirectory class methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'revelations 11/2/2011 12:40'!
onClient
	^ false! !

!FileDirectory methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'revelations 11/2/2011 13:40'!
fileNamed: localFileName do: aBlock
	| file |
	file := self fileNamed: localFileName.
	^ [ aBlock value: file ] ensure: [ file close ]! !

!FileDirectory methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'galatians 05/13/2005 14:15'!
forceNewFileNamed: localFileName do: aBlock
	| file |
	file := self forceNewFileNamed: localFileName.
	^ [ aBlock value: file ] ensure: [ file close ]! !

!MCStWriter methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'galatians 05/13/2005 14:15'!
initializers: aCollection! !

!MCFileTreeRepository methodsFor: '*monticellofiletree-gemstone-extensions' stamp: 'revelations 11/2/2011 13:07'!
versionReaderForFileNamed: aString do: aBlock
	^ self
		readStreamForFileNamed: aString
		do: [ :s | (MCVersionReader readerClassForFileNamed: aString) ifNotNil: [ :class | aBlock value: (class on: s fileName: aString) ] ]! !
